local B = CBW_Battle
local S = B.SkinVars

addHook("PlayerSpawn", function(player)
		player.battlethok = 2*TICRATE+1
		player.thokreadyeffect = false
end)

addHook("PlayerThink", function(player)
	if player.battlethok == nil then // set cooldown var
		player.battlethok = 2*TICRATE+1
		player.thokreadyeffect = false
	end
	
	if not player.mo
		return 
	end
	
	if player.mo and player.mo.skin != "sonic"
		return 
	end
	
	if player.mo and P_IsObjectOnGround(player.mo) then
		player.thokfastfall = false
	end
	
	if player.mo and player.speed >= player.runspeed/2 or player.dashspeed > 1*player.mo.scale or abs(player.mo.momz) > player.runspeed/3 then
		if player.battlethok < 3*TICRATE then
			player.battlethok = $+1
			player.thokreadyeffect = false
			if (player.mo.eflags & MFE_SPRUNG) then
			player.battlethok = 3*TICRATE
			end
		elseif not player.thokreadyeffect then 
			local tghost = P_SpawnGhostMobj(player.mo)
			tghost.destscale = player.mo.scale*2
			tghost.momx = player.mo.momx
			tghost.momy = player.mo.momy
			tghost.momz = player.mo.momz
			player.thokreadyeffect = true
			player.battlethok = 3*TICRATE
			if player == consoleplayer //feel when its ready
						P_StartQuake(3*FRACUNIT,1)
			end
			if player.powers[pw_super] then
				player.pflags = $&~PF_THOKKED
			end
		end
	end

end)

addHook("AbilitySpecial", function(player) // make a thok that's speed is tied to a cooldown
	
	if player.mo.skin != "sonic" or player.gotflagdebuff then
		return 
	end
	
	if (player.mo.state >= S_PLAY_SPRING ) or (player.battlethok <= TICRATE*1 and player.pflags&PF_THOKKED)
	or player.actionstate == 10 then  //state_superspinwave
								
		return true end
	if player.battlethok >= 1*TICRATE then
		local thokpower = (player.battlethok/TICRATE)
		local actionspd = FixedMul(player.mo.scale, player.actionspd)*thokpower
		if (player.mo.eflags & MFE_UNDERWATER)
			actionspd = $/2
		end
		P_InstaThrust(player.mo, player.mo.angle, actionspd)
		P_SpawnThokMobj(player)
		if player.battlethok > 2*TICRATE then // create turbulance thing
			local turbulence = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOKTURBULENCE)
			turbulence.thokspeed = actionspd/2
			turbulence.thokangle = player.mo.angle
			turbulence.angle = player.mo.angle+ANGLE_90
			turbulence.target = player.mo
			turbulence.scale = player.mo.scale/3
			turbulence.destscale = player.mo.scale*2
			turbulence.color = player.mo.color
		end
		if player.powers[pw_sneakers] then
			player.battlethok = $-(TICRATE/2)
		else
			player.battlethok = $-(TICRATE*3/2)
		end
		S_StartSound(player.mo, sfx_thok)
		player.pflags = $|PF_THOKKED
		return true
	end

end)

addHook("TouchSpecial", function(obj,mo)

	if obj.target == mo then
		return true
	else
		P_Thrust(mo, obj.thokangle, obj.thokspeed)
		P_SpawnThokMobj(mo.player)
		S_StartSound(mo, sfx_s3k4b)
		
	end
	
end, MT_THOKTURBULENCE)
