	local B = CBW_Battle
	local cooldown = TICRATE * 3
	local cooldown_bigjump = TICRATE * 4
	local cancelcooldown = TICRATE
	local colldown_epunch = TICRATE*7/5
	local state_digging = 1
	local state_drilldive = 2
	local state_burrowed = 3
	local state_rising = 4
	local state_punch = 10
	local setburrowtime = TICRATE/5 //Time in tics before the player can move after burrowing //was TICRATE/2
	local rockblasttime_x = 35 //Time in tics before horizontal rockblast disappears
	local rockblasttime_y = 47 //Time in tics before vertical rockblast disappears
	local zthreshold = 8 //Z Distance from ground (in fracunits) that will cause Knuckles to resurface

B.Action.Dig_Priority = function(player)
	if player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_GLIDE_LANDING then
			B.SetPriority(player,0,0,"knuckles_glide",0,1,"dashing fist")
		end
		// have to add back in attack propertes of glide because srb2 is dumb
		if player.mo.state == S_PLAY_GLIDE then
			B.SetPriority(player,1,0,"knuckles_glide",2,1,"gliding fists")
		end
		if player.actionstate == state_drilldive then
			B.SetPriority(player,2,2,"fang_tailbounce",3,2,"drill dive")
		end
		if player.actionstate == state_rising then
			B.SetPriority(player,1,1,nil,1,1,"rising drill")
		end
		if player.actionstate == state_burrowed then
			B.SetPriority(player,2,2,nil,2,2,"super buster")
		end
		if player.mo.state == S_PLAY_K_PUNCHACTIVE1 then
			B.SetPriority(player,0,0,"knuckles_glide",2,5,"explosive punch")
		end
		if  player.mo.state == S_PLAY_K_PUNCHSTART1 or 
		player.mo.state == S_PLAY_K_PUNCHRECOVERY or player.mo.state == S_PLAY_K_PUNCHSTART2 then
			B.SetPriority(player,0,0,"knuckles_glide",1,0,"punch recoil")
		end
end

local rock_properties = function(rock,rockblasttime)
	rock.fuse = rockblasttime
	if G_GametypeHasTeams() and rock.target and rock.target.valid and rock.target.player then
		rock.color = rock.target.player.skincolor
		rock.colorflash = true
	end
end

local shootrock_grounded = function(mo,ang1,ang2,scale,rockblasttime)
	local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
	if rock and rock.valid then
		B.InstaThrustZAim(rock,ang1,ang2*P_MobjFlip(rock),scale)
		rock_properties(rock,rockblasttime)
	end
end

local shootrock_sidewall = function(mo,ang1,ang2,scale,rockblasttime)
	local rock = P_SPMAngle(mo,MT_ROCKBLAST,0,0)
	if rock and rock.valid then
		B.InstaThrustSpread(rock,mo.angle,ang1,ang2,scale)
		rock_properties(rock,rockblasttime)
	end
end


local rockblast = function(mo,grounded)
	if grounded then
		//Do horizontal debris burst
		//Anti-air Layer
		local m = 4
		for n = 0,m
			shootrock_grounded(mo,(360/m)*n*ANG1,85*ANG1,mo.scale*18,rockblasttime_y)
		end
		//Second Layer
		local m = 6
		for n = 0,m
			shootrock_grounded(mo,(360/m)*n*ANG1,80*ANG1,mo.scale*14,rockblasttime_y)
		end
		//Third Layer
		local m = 8
		for n = 0,m
			shootrock_grounded(mo,(360/m)*n*ANG1,75*ANG1,mo.scale*11,rockblasttime_y)
		end
		//Ground Layer
		local m = 24
		for n = 0,m
			shootrock_grounded(mo,(360/m)*n*ANG1,1*ANG10,mo.scale*12,rockblasttime_x)
		end
	else
		//Do vertical debris burst
		for n = 0,7
			shootrock_sidewall(mo,30,45*n,mo.scale*20,rockblasttime_y)
		end
		//Second Layer
		for n = 0,15
			shootrock_sidewall(mo,60,225*n/10,mo.scale*15,rockblasttime_y)
		end
	end
end

B.Action.Dig=function(mo,doaction)
	local player = mo.player

	if P_PlayerInPain(player)
	or player.playerstate != PST_LIVE
	or (player.actionstate == state_drilldive and player.powers[pw_nocontrol])
		if P_PlayerInPain(player) and player.actionstate
			B.ResetPlayerProperties(player,false,false)
		end
	return end
	if not(B.CanDoAction(player))
		if B.GetSVSprite(player)
			B.ResetPlayerProperties(player,false,false)
		return end
	end

	local dojump = B.PlayerButtonPressed(player,BT_JUMP,false)
	local dospin = B.PlayerButtonPressed(player,BT_SPIN,false)
	local climbing = player.climbing
	local sludge = mo.eflags&MFE_GOOWATER
	local grounded = P_IsObjectOnGround(mo)
	local diggingstates = (player.actionstate == state_digging or player.actionstate == state_burrowed)
	local getcanceltics = player.actiontime
	local floordist
	local spining = false
	local thrustpower = 12
	local thrustfactor = mo.scale
	if player.pflags &(PF_SPINNING|PF_STARTDASH) then
	spining = true	end
	if P_MobjFlip(mo) == 1 then
		floordist = mo.z-mo.floorz
	else
		floordist = mo.ceilingz-mo.height-mo.z
	end
	local nearground = (floordist < zthreshold*mo.scale)
	
	//****
	//Action properties &HUD
	
	player.actiontextflags = 0

	//Normal state; ready to dig
	if player.actionstate == 0 then
		if not P_IsObjectOnGround(mo) or spining then
			player.actiontext = "Dig"
			player.actionrings = 10
		else
			player.actiontext = "Explosive Punch"
			player.actionrings = 10
		end
	//2 = downward air drill; disallow actions.
	elseif not(diggingstates)
		player.actiontext = nil
	//1 = digging, disallow actions. 3 = Burrowed; ready to resurface.
	else
		if player.actionstate == 1 then
			player.actiontextflags = 1

		end
		player.actiontext = "Rock Blast"
		player.actionrings = 0 
		if player.actionrings > player.rings then
			player.actiontextflags = 3
		end
		player.action2text = "Resurface "..player.exhaustmeter*100/FRACUNIT.."%"
	end
	
	//Check rings
	if (diggingstates and dojump) then
		doaction = 1
	end
	
	//Action triggers

	local trigger_punch = 
		(doaction == 1 and grounded and player.actionstate == 0 and not spining)
	local trigger_dig =
		(doaction == 1 and not(sludge) and player.actionstate == 0 and ((grounded and spining) or climbing)) //grounded
		or (grounded and player.actionstate == state_drilldive and not(sludge))
	local trigger_drilldive = (not(grounded and not sludge) and doaction == 1 and player.actionstate == 0)
	local trigger_drilldive_cancel = (player.actionstate == state_drilldive and mo.momz*P_MobjFlip(mo) > 0)
	local trigger_eject =
		(player.exhaustmeter == 0)
		or (grounded and sludge)
		or (player.actionstate == state_burrowed and dospin)
		or not(nearground or climbing)	
	
	//Execute Punch//
	if trigger_punch
		if player.actionstate == 0 then
			B.PayRings(player)
		end
		player.mo.state = S_PLAY_K_PUNCHSTART1
		player.actionstate = state_punch
		player.drawangle = player.mo.angle
		player.actiontime = 0
		player.canguard = false
		player.epunchjump = false
		player.lockmove = true
		player.lockaim = true
		player.mo.friction = FRACUNIT*1 // slide around
		player.pflags = $&~PF_APPLYAUTOBRAKE // no auto break
		return
	end 
	
	//----- punch code -----//
	if player.actionstate == state_punch then 
		player.actiontime = $+1
		player.lockaim = true
		if player.pflags&PF_ANALOGMODE then // not ideal but it will do
			player.lockmove2 = true
		end
		player.pflags = $ & ~PF_SPINNING
		player.pflags = $|PF_THOKKED
		player.punchthrustedit = true
		player.thrustfactor = skins[mo.skin].thrustfactor*3/5
		if player.actiontime <= 23 then // start up code
			player.squashstretch = true
			player.pflags = $&~PF_APPLYAUTOBRAKE // no auto break
			player.mo.friction = FRACUNIT*1
			if player.actiontime < 13 then // slide
				//player.pflags = $|PF_STASIS // let the player jump
				if player.actiontime <= 6 then // start up pose 1
					mo.state = S_PLAY_K_PUNCHSTART1
					mo.frame = 2
				else  // start up pose 2
					mo.state = S_PLAY_K_PUNCHSTART2
					mo.frame = 0
				end
			elseif player.actiontime == 14 then // push forward
				player.lockmove = true
				player.mo.spritexscale = FRACUNIT * 5/4
				player.mo.spriteyscale = FRACUNIT * 4/5
				if player == consoleplayer //make it feel powerful
					P_StartQuake(4*FRACUNIT,1)
				end
				P_Thrust(mo,player.drawangle,thrustfactor*thrustpower)
				mo.state = S_PLAY_K_PUNCHACTIVE1
				local jabhitbox = P_SpawnMobjFromMobj(player.mo, FixedMul(player.mo.radius, cos(player.mo.angle)),
				 FixedMul(player.mo.radius, sin(player.mo.angle)), 0, MT_JABEXPLOADE)// spawn exlosion hitbox
				jabhitbox.target = player.mo
				jabhitbox.noactivetime = false
				S_StartSound(player.mo, sfx_brakrx)
			elseif player.actiontime <= 23
				mo.state = S_PLAY_K_PUNCHACTIVE1
				player.lockmove = true // dont cancle punch into jump
			end
			player.canguard = false
		elseif player.actiontime > 23 then // recovery
			player.lockmove = true
			player.canguard = true
			mo.state = S_PLAY_K_PUNCHRECOVERY
			mo.frame = 0
		end
		if player.actiontime >= 35  then
			B.ApplyCooldown(player,colldown_epunch)
			B.ResetPlayerProperties(player,false,false)
			player.thrustfactor = skins[mo.skin].thrustfactor
			player.punchthrustedit = false
			player.mo.state = S_PLAY_WALK
		end
	end
	
	//Execute dig // 
	if trigger_dig
		if player.actionstate == 0 then
			B.PayRings(player)
		end
		player.actionstate = state_digging
		player.actiontime = 0
		player.exhaustmeter = min(FRACUNIT,$+FRACUNIT/4)
		mo.flags = $|MF_NOCLIPTHING
		mo.flags2 = $|MF2_DONTDRAW
		player.delayblast = nil
		player.pflags = ($|PF_JUMPSTASIS) & ~PF_SPINNING
		player.normalspeed = skins[mo.skin].normalspeed*3/5
		S_StartSound(mo,sfx_s3kccs)
		player.canguard = 0
		return
	end
	
	//Execute downward air drill
	if trigger_drilldive
		B.PayRings(player)
		player.actionstate = state_drilldive
		mo.state = S_PLAY_ROLL
		local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
		local speed = FixedHypot(mo.momx,mo.momy)
		B.InstaThrustZAim(mo,dir,-ANGLE_90,min(speed,mo.scale*36))
		mo.momz = min(-12*mo.scale,$*P_MobjFlip(mo))*P_MobjFlip(mo)
		player.pflags = $|(PF_JUMPED|PF_THOKKED)&~(PF_GLIDING)
		S_StartSound(mo,sfx_zoom)
		return
	end
	
	//Drill dive
	if player.actionstate == state_drilldive then
		player.actiontime = $+1
		B.DrawSVSprite(player,1+player.actiontime%4)
		P_SpawnGhostMobj(mo)
		
		if B.ButtonCheck(player, BT_JUMP) == 1 and player.exhaustmeter
			B.ResetPlayerProperties(player,true,false)
			B.ApplyCooldown(player,cancelcooldown)
			
			mo.momz = $ / 3
			
			local glidespeed = FixedMul(player.actionspd, player.mo.scale)
			local playerspeed = player.speed

			if (player.mo.eflags & MFE_UNDERWATER)
				glidespeed = $ >> 1
				playerspeed = 2*playerspeed/3
				if (!(player.powers[pw_super] or player.powers[pw_sneakers]))
					player.mo.momx = (2*(player.mo.momx - player.cmomx)/3) + player.cmomx
					player.mo.momy = (2*(player.mo.momy - player.cmomy)/3) + player.cmomy
				end
			end
			
			player.pflags = $ | PF_GLIDING|PF_THOKKED
			player.glidetime = 0

			player.mo.state  = S_PLAY_GLIDE
			if (playerspeed < glidespeed)
				P_Thrust(player.mo, player.mo.angle, glidespeed - playerspeed)
			end
			player.pflags = $ & ~(PF_SPINNING|PF_STARTDASH)
		end
	end
	//Cancel drill dive
	if trigger_drilldive_cancel then
		mo.state = S_PLAY_FALL
		B.ResetPlayerProperties(player,false,false)
		B.ApplyCooldown(player,cancelcooldown)
	end
	
	//Drill rise
	if player.actionstate == state_rising
		player.actiontime = $+1
		B.DrawSVSprite(player,(player.actiontime/2)%4+5)
		//End rising state
		if P_MobjFlip(mo)*mo.momz <= 0 or P_IsObjectOnGround(mo)
			B.ResetPlayerProperties(player,true,false)
			player.exhaustmeter = FRACUNIT / 2 + 1
		end
	end
	
	//Gate: Digging states only
	if not(diggingstates)
		then return 
	end
	
	//Eject player from burrow state
	if trigger_eject then
		P_SetObjectMomZ(mo,FixedMul(FRACUNIT*6,player.jumpfactor),false)
		B.ResetPlayerProperties(player,false,false)
		player.bumpedability = true // allow player to glide?
		player.pflags = $| PF_SHIELDABILITY // no wind shield
		mo.state = S_PLAY_FALL
		S_StartSound(mo,sfx_s3k82)
		for n = 0, 10
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(5,10))
		end
		//Apply cooldown
		B.ApplyCooldown(player,cancelcooldown)
		player.powers[pw_nocontrol] = 2
		player.actiontime = 0
		mo.momx = $ / 3
		mo.momy = $ / 3
		return
	end
	
	//Burrowed properties
	mo.flags = $|MF_NOCLIPTHING //Intangibility
	mo.flags2 = $|MF2_DONTDRAW //Invisibility
	player.charability2 = 0 //Disallow spindashing
	player.canguard = false //Disallow guarding
	
	//Clip to ground
	if not(climbing) then
		if P_MobjFlip(mo) == 1 then
			mo.z = mo.floorz
		else
			mo.z = mo.ceilingz-mo.height
		end
	end
	
	//Timers
	player.actiontime = $+1
	if player.exhaustmeter and P_IsObjectOnGround(mo)
		player.exhaustmeter = max(0,$-FRACUNIT/TICRATE/4) // default time 3, stay in ground a little longer
	end
	
	//Smoke
	if (player.exhaustmeter > FRACUNIT/3 and player.actiontime%TICRATE == 0)
	or (player.exhaustmeter <= FRACUNIT/3 and player.actiontime%(TICRATE/3) == 0)
		local smoke = P_SpawnMobj(mo.x,mo.y,mo.z,MT_SMOKE)
		if G_GametypeHasTeams()
			smoke.colorized = true
			smoke.color = player.skincolor
		end
	end
	
	//Digging state
	if player.actionstate == state_digging
		player.pflags = $|PF_JUMPSTASIS//|PF_STASIS
		player.mo.friction = FRACUNIT*1 // slide around
		if player.actiontime >= setburrowtime
			player.actionstate = state_burrowed
		end
		B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(5,20))
		return
	end
	player.pflags = ($|PF_JUMPSTASIS)//&~PF_STASIS

	//Moving while burrowed
	if abs(player.cmd.forwardmove) or abs(player.cmd.sidemove) then
		if not(player.actiontime&3) then
			//Do Debris
			B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(3,5))
			S_StartSound(mo,sfx_s3k67)
		end
	end
	
	grounded = P_IsObjectOnGround(player.mo)
	//Rock blast attack 2
	if (player.delayblast )
		then
		if (player.delayblast <= 1) then
			player.exhaustmeter = 0
			player.pflags = $&~PF_JUMPSTASIS
			P_DoJump(player,false)
			B.ResetPlayerProperties(player,true,true)
			if grounded
				player.actionstate = state_rising
				B.DrawSVSprite(player,5)
			end
			if player.cmd.buttons&BT_JUMP then
				mo.momx = $ / 3
				mo.momy = $ / 3
				player.pflags = $|PF_STARTJUMP|PF_JUMPDOWN
				B.ZLaunch(mo, FRACUNIT*9/2, true)
			else
				//B.ApplyCooldown(player,cooldown)
			end

			for n = 0, 7
				B.DoDebris(mo,P_RandomChance(FRACUNIT/2),P_RandomRange(3,20))
			end
			rockblast(mo,grounded)
			player.delayblast = nil
		else
		player.delayblast = $-1
		end
	end
	//Delay blast attack
		if (doaction == 1)
			then
			B.PayRings(player)
			B.ApplyCooldown(player,getcanceltics+cooldown)
			S_StartSound(mo,sfx_s3k59)
							//------------hitbox-------//
			mo.hitbox = P_SpawnPlayerMissile(mo, MT_DIGHITBOX)
			if mo.hitbox != nil and mo.hitbox.valid then
				mo.hitbox.state = S_DBOX1
			end
			player.delayblast = 2
		end
end// end of function

B.DoDebris=function(mo,large,speed)
	local scale
	if large then scale = mo.scale/2
	else scale = mo.scale/3
	end
	local debris = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ROCKCRUMBLE2)
	if debris and debris.valid then
		if G_GametypeHasTeams() and mo.player
			debris.colorized = true
			debris.color = mo.player.skincolor
		end
		debris.scale = scale
		debris.flags2 = $|(mo.flags2&MF2_OBJECTFLIP)
		debris.z = $+FRACUNIT
		if P_IsObjectOnGround(mo) then
			P_InstaThrust(debris,P_RandomRange(0,259)*ANG1,speed*scale)
			debris.momz = speed*scale*P_MobjFlip(mo)
		else
			B.InstaThrustZAim(debris,mo.angle+ANGLE_180+P_RandomRange(-89,89)*ANG1,P_RandomRange(-89,89)*ANG1,speed*scale)
		end
	end
	return debris
end

B.RockBlastObject = function(mo)
	if mo.colorflash == true then
		mo.colorized = (mo.fuse%8 == 0)
	end
end

B.Knuckles_Collide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
	if plr[n1] and mo[n1].health and not(pain[n1])
		and (plr[n1].pflags&PF_GLIDING or plr[n1].climbing 
			or (plr[n1].charability == CA_GLIDEANDCLIMB) and collisiontype > 1 and P_IsObjectOnGround(mo[n1]) and not(plr[n1].pflags&PF_SPINNING)
		) then
		plr[n1].pflags = $&~(PF_GLIDING|PF_JUMPED)
		if not(P_IsObjectOnGround(mo[n1])) and not(plr[n1].climbing) then
			plr[n1].panim = PA_FALL
			mo[n1].state = S_PLAY_FALL
			plr[n1].climbing = 0
			plr[n1].lastsidehit = -1
			plr[n1].lastlinehit = -1
			
			P_Thrust(mo[n1],mo[n1].angle + ANGLE_180, 6*FRACUNIT)
			P_SetObjectMomZ(mo[n1], 2*FRACUNIT/B.WaterFactor(mo[n1]), true)
		elseif (atk[n2])
			mo[n1].state = S_PLAY_GLIDE_LANDING
		end
	end
	return false
end